jumpgame.cpp File Reference

Implementation of an algorithm to solve the jumping game problem. More...

`#include <vector>`
`#include <iostream>`
`#include <cassert>`
Include dependency graph for jumpgame.cpp:

## Functions

bool | canJump (const std::vector< int > &nums)
| This function implements the above algorithm. More...
static void | test ()
| Function to test above algorithm. More...
int | main ()
| Main function. More...

## Detailed Description

Implementation of an algorithm to solve the jumping game problem.

Problem statement: Given an array of non-negative integers, you are initially positioned at the first index of the array. Each element in the array represents your maximum jump length at that position. Determine if you are able to reach the last index. This solution takes in input as a vector and output as a boolean to check if you can reach the last position. We name the indices good and bad based on whether we can reach the destination if we start at that position. We initialize the last index as lastPos. Here, we start from the end of the array and check if we can ever reach the first index. We check if the sum of the index and the maximum jump count given is greater than or equal to the lastPos. If yes, then that is the last position you can reach starting from the back. After the end of the loop, if we reach the lastPos as 0, then the destination can be reached from the start position.

Author
  Rakshaa Viswanathan

## Function Documentation

## canJump()

bool canJump | ( | const std::vector< int > & | nums | ) |

This function implements the above algorithm.

Parameters

  array | of numbers containing the maximum jump (in steps) from that index

Returns
  bool value whether final index can be reached or not

{
auto lastPos = nums.size() - 1;
for (auto i = nums.size() - 1; i >= 0; i--) {
if (i + nums[i] >= lastPos) {
lastPos = i;
}
}
return lastPos == 0;
}
std::vector::size
T size(T... args)
Here is the call graph for this function:

## main()

int main | ( | void |  | ) |

Main function.

Returns
  0 on exit

{
test();
return 0;
}
test
static void test()
Function to test above algorithm.
Definition: jumpgame.cpp:41
Here is the call graph for this function:

## test()

static void test | ( |  | ) |

static

Function to test above algorithm.

Returns
  void

{
// Test 1
std::vector<int> num1={4,3,1,0,5};
assert(canJump(num1)==true);
std::cout<<"Input: ";
for(auto i: num1){
std::cout<<i<<" ";
}
std::cout<<"Output: true"<<std::endl;
// Test 2
std::vector<int> num2={3,2,1,0,4};
assert(canJump(num2)==false);
std::cout<<"Input: ";
for(auto i: num2){
std::cout<<i<<" ";
}
std::cout<<"Output: false"<<std::endl;
}
std::cout
std::endl
T endl(T... args)
canJump
bool canJump(const std::vector< int > &nums)
This function implements the above algorithm.
Definition: jumpgame.cpp:26
std::vector< int >
Here is the call graph for this function: